import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { map } from 'rxjs/operators';
import { DeaggResponse } from '@ghsc/nshmp-utils/nshmp-haz';
import { throwError, Observable } from 'rxjs';

@Injectable({
  providedIn: 'root',
})
export class AppService {
  url = 'https://earthquake.usgs.gov/nshmp-haz-ws/deagg/E2014B/COUS/-104/39/PGA/760/2475';

  constructor(private http: HttpClient) {}

  get callDeagg$(): Observable<DeaggResponse> {
    return this.http.get(this.url).pipe(
      map((response: DeaggResponse) => {
        if (response.status === 'error') {
          throwError(response['message']);
        }
        return response;
      })
    );
  }
}
